<script setup>

import { reactive } from 'vue';
import { useRouter } from 'vue-router';
import { openCoinfolioUrl } from '../lib/CoinfolioAPI';

let router = useRouter();

let state = reactive({
    coinfolioTitle: ""
});

async function openCoinfolio() {
    const newCoinfolio = {
        title: state.coinfolioTitle,
    };

    const res = await fetch(openCoinfolioUrl, {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
        },
        body: JSON.stringify(newCoinfolio)
    });

    if(res.status != 200) {
        alert("failed to create coinfolio!");
        return;
    }

    let { id, ownerToken } = await res.json();

    let persistedCoinfolios = [];
    let persistedCoinfoliosJson = window.localStorage.getItem("coinfolios");
    if(persistedCoinfoliosJson) {
        persistedCoinfolios = JSON.parse(persistedCoinfoliosJson);
    }

    persistedCoinfolios.push({ id, ownerToken });
    window.localStorage.setItem("coinfolios", JSON.stringify(persistedCoinfolios));

    router.push("/");
}
</script>

<template>
    <h1>Create a new CoinFolio</h1>
    <input type="text" v-model="state.coinfolioTitle" placeholder="CoinFolio Title"/>
    <button @click.prevent="openCoinfolio">Open CoinFolio</button>
</template>